<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

/**
CREATE TABLE `categories` (
    id      INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
    name    VARCHAR(255) NOT NULL,

    created_at DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY(`id`),
    UNIQUE KEY(`name`)
);
 */

final class CreateCategoriesTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $table = $this->table('categories')->addTimestamps();

        $table->addColumn('name', 'string', [ 'null' => false ])
              ->addIndex([ 'name' ], [ 'unique' => true ]);

        $table->create();
    }
}
