<?php

namespace Slovocast\Domain;

use DateTime;
use DateTimeImmutable;

trait Record
{
    protected ?DateTimeImmutable $createdAt;
    protected ?DateTime $updatedAt;

    public function setCreatedAt(DateTimeImmutable $createdAt): void
    {
        $this->createdAt = $createdAt;
    }

    public function getCreatedAt(): DateTimeImmutable
    {
        return $this->createdAt;
    }

    public function setUpdatedAt(DateTime $updatedAt): void
    {
        $this->updatedAt = $updatedAt;
    }

    public function getUpdatedAt(): DateTime
    {
        return $this->updatedAt;
    }

    public function markUpdated(): void
    {
        $this->updatedAt = new DateTime();
    }

    public function markCreated(): void
    {
        $this->createdAt = new DateTimeImmutable();
        $this->updatedAt = new DateTime();
    }
}
