<?php

namespace Slovocast\Domain\Repository\Episode;

use Slovocast\Domain\Entity\Episode;
use Slovocast\Domain\Entity\Channel;

interface EpisodeRepositoryInterface
{
    public function get(int $id): Episode;

    /**
     * @param Channel $channel
     * @return Episode[]
     */
    public function getFromChannel(Channel $channel): array;
    public function create(Episode $episode): Episode;
    public function update(Episode $episode): bool;
    public function delete(Episode $episode): bool;
}
