<?php

namespace Slovocast\Middleware;

use Odan\Session\SessionInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface as RequestHandler;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ResponseFactoryInterface;

class VerifyPasswordMiddleware implements MiddlewareInterface
{
    public function __construct(
        private SessionInterface $session,
        private ResponseFactoryInterface $responseFactory
    ) {}

    public function process(Request $request, RequestHandler $handler): Response
    {
        // get user Data
        $requestData = $request->getParsedBody();

        if ($requestData['password'] !== $requestData['checked_password']) {
            $message = "Passwords do not match.";
            $this->session
                 ->getFlash()
                 ->add('error', $message); 

            // throw an error? send it back to the register screen?
            $response = $this->responseFactory->createResponse(400, $message); 
            return $response;
        }

        return $handler->handle($request);
    }
}
